#ifndef S9X_PREFS_H
#define S9X_PREFS_H

#include <string>
#include "defines.h"
#include "frend.h"
#include "skins.h"
#include "misc.h"

namespace s9x {

class Interface;

class Prefs: public frend::Window, public OptionManager, private frend::Listener
{
 private:
	frend::Element*		_banner;
	frend::Notebook		_notebook;
	frend::Notepage		_appearance_pg, _paths_pg, _reset_pg, _power_pg;
	frend::RadioGroup	_videodriver;
	frend::RadioButton	_use_x11, _use_opengl, _use_glide;
	frend::Checkbox		_start_with_defaultprofile, _start_with_lastplayed;
	frend::Checkbox		_reset_to_defaultprofile, _reset_to_lastplayed, _reset_to_args;
	frend::NumEntry		_snes9x_version;
	frend::File		    _rom_dir, _snap_dir, _snes9x_dir;
	frend::Button		_close_btn;
	File                _prefs_file;
	SkinSelector        _skinselector;
	bool                _loaded;
	frend::ArgList		_saved_args;
	void _createAppearancePg();
	void _createPathsPg();
	void _createResetPg();
	void _createPowerPg();
	void _applyPaths();
	void _applySkin();
	void _apply9xVersion();
	void _applyExecutable();
	void eventOccurred(frend::Event*e);
 public:
	Prefs(frend::Element*parent);
	virtual ~Prefs();
	void setToDefaults();
	void siftArgs(frend::ArgList&);
	void load();
	void apply();
	void saveIfUpdated();
	std::string getROMdir();
	std::string getSnapDir();
	std::string getSnes9xDir();
	void applySkin(Skin*);
	bool getResetToDefaultProfile()   { return _reset_to_defaultprofile.getState(); };
	bool getResetToArgs()             { return _reset_to_args.getState(); };
	bool getResetToLastPlayed()          { return _reset_to_lastplayed.getState(); };
	bool getStartWithDefaultProfile() { return _start_with_defaultprofile.getState(); }
	bool getStartWithLastPlayed()        { return _start_with_lastplayed.getState(); }
};

}

#endif
