#ifndef S9X_PROFILER_H
#define S9X_PROFILER_H

#include "defines.h"
#include "frend.h"
#include "misc.h"
#include "skins.h"
#include <string>

namespace s9x {

enum ProfileState
{
	PROFILE_STATE_DEFAULT,
	PROFILE_STATE_SAVED,
	PROFILE_STATE_TEMP,
	PROFILE_STATE_DELETED
};

class Interface;

class Profiler :	public frend::Window, private frend::Listener
{
 private:
	frend::Element   *_logo;
	frend::Box       *_logo_box;
	frend::Text      _prof_name;
	frend::Button    _close_btn;
	frend::Button    _apply_btn, _save_btn, _def_btn, _del_btn;
	frend::Image     _def_img, _sav_img, _del_img, _tmp_img;
	frend::Box       _btnbox;
	frend::DataTable _profile_list;
	File             _profile_file;
	bool             _loading, _save_needed;
	const char       *_new_profile_name;
	void           _createProfileList();
	void           _createButtonBar();
	int            _loadList();
	void           _setProfile(int row, ProfileState s, const std::string& name, const std::string& args);
	void           _setRowState(int row, ProfileState s);
	ProfileState   _getRowState(int row);
	void           _changeState(ProfileState s);
	std::string    _getRowName(int row);
	std::string    _getRowArgsEncoded(int row);
	frend::ArgList *_getRowArgList(int row);
	int            _getDefaultRow();
	int            _getSelectedRow();
	void           _applyRow(int row);
	void           _apply();
	void           eventOccurred(frend::Event*e);
 public:
	Profiler(frend::MainProgram*parent);
	~Profiler();
	void setVisibility(bool s);
	void rowSelected(int row);
	void nameUpdated();
	void applyDefaultProfile();
	void applySkin(Skin*);
	int  saveIfUpdated();
};

}

#endif
