#ifndef S9X_VIDEO_H
#define S9X_VIDEO_H

#include "defines.h"
#include "frend.h"
#include "misc.h"
#include "skins.h"

namespace s9x {

class Video :       public Notepage
{
 private:
	frend::Checkbox      _scale, _hires, _fullscreen;
	frend::PulldownMenu  _video_system, _tvmode;
	frend::Checkbox      _use_frameskip, _use_frametime, _display_framerate;
	frend::NumEntry      _frameskip, _frametime;
	frend::Label         _frameskip_label, _frametime_label;
	frend::MenuItem      *_ntsc, *_pal, *_tv_modes[5];
	void eventOccurred(frend::Event*e);
 public:
   Video(frend::Notebook*parent);
   ~Video();
   void setToDefaults();
   void set9xVersion(float version);
   void siftArgs(frend::ArgList&);
   void compileArgs(frend::ArgList&);
};

}

#endif
